import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:flutter_conscent_plugin/flutter_conscent_plugin_method_channel.dart';

void main() {
  MethodChannelFlutterConscentPlugin platform = MethodChannelFlutterConscentPlugin();
  const MethodChannel channel = MethodChannel('flutter_conscent_plugin');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await platform.getPlatformVersion(), '42');
  });
}
