import 'package:flutter_test/flutter_test.dart';
import 'package:flutter_conscent_plugin/flutter_conscent_plugin.dart';
import 'package:flutter_conscent_plugin/flutter_conscent_plugin_platform_interface.dart';
import 'package:flutter_conscent_plugin/flutter_conscent_plugin_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockFlutterConscentPluginPlatform
    with MockPlatformInterfaceMixin
    implements FlutterConscentPluginPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final FlutterConscentPluginPlatform initialPlatform = FlutterConscentPluginPlatform.instance;

  test('$MethodChannelFlutterConscentPlugin is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelFlutterConscentPlugin>());
  });

  test('getPlatformVersion', () async {
    FlutterConscentPlugin flutterConscentPlugin = FlutterConscentPlugin();
    MockFlutterConscentPluginPlatform fakePlatform = MockFlutterConscentPluginPlatform();
    FlutterConscentPluginPlatform.instance = fakePlatform;

    expect(await flutterConscentPlugin.getPlatformVersion(), '42');
  });
}
